//******************************************************************************
//* Copyright Jimmy Rasmussen
//* Description : This program is solely made for editing the delphi repository
//*               file.(delphi32.dro) Either by editing the changes directly or
//*               selecting the files, which should be added to the repository,
//*               this requieres some editing afterwards.
//* Version     : 1.0, 1998/07/29
//******************************************************************************
//* Things to do : Make the line number 100% correct. Seems to be a problem on
//*                key down and up ? (NOTE VK_END and VK_HOME is not supported)
//*              : Read ancestor name from pas file, and find path to ancestor.
//*              : Make some changes to the float behaviour.

unit fdroreg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, StdCtrls, Menus, ComCtrls, ToolWin, ExtCtrls, FileCtrl, ImgList;

type
  TEDroreg = class(TForm)
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    FileBtn: TToolButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    Openregistry1: TMenuItem;
    Exit1: TMenuItem;
    Saveregistry1: TMenuItem;
    ActionList1: TActionList;
    OpenRep: TAction;
    OpenDialog: TOpenDialog;
    SaveRep: TAction;
    Exit: TAction;
    Panel1: TPanel;
    Memo1: TMemo;
    Panel2: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FBox1: TFileListBox;
    ADD1: TMenuItem;
    AddToRep: TAction;
    ToolButton3: TToolButton;
    RepPages: TComboBox;
    Panel3: TPanel;
    StatBar: TStatusBar;
    ControlBar2: TControlBar;
    Messageview: TMemo;
    ImagList: TImageList;
    ToolButton1: TToolButton;
    Etellerandet1: TMenuItem;
    MChosepage1: TMenuItem;
    AChoosePage: TAction;
    AMessageView: TAction;
    MMessageview1: TMenuItem;
    AFloatWindows: TAction;
    procedure OpenRepExecute(Sender: TObject);
    procedure SaveRepExecute(Sender: TObject);
    procedure ExitExecute(Sender: TObject);
    procedure AddToRepExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1Enter(Sender: TObject);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AChoosePageExecute(Sender: TObject);
    procedure AMessageViewExecute(Sender: TObject);
    procedure AFloatWindowsExecute(Sender: TObject);
  private
    { Private declarations }
    Navne   : Array of String;
    MemoPos : Array of Integer;
    RepPos  : Integer;
  Public
    { Public declarations }
  end;

var
  EDroreg: TEDroreg;

implementation

{$R *.DFM}

procedure TEDroreg.OpenRepExecute(Sender: TObject);
Var I : Integer;
begin
  If OpenDialog.execute Then Begin
    Memo1.Lines.Clear;
    Memo1.Lines.LoadFromFile(Opendialog.FileName);
    SaveRep.Enabled  := TRUE;
    AddToRep.Enabled := TRUE;
    RepPos := Memo1.Lines.IndexOf('[Repository Pages]')+1;
    RepPages.Items.Clear;
    For I := RepPos To Memo1.Lines.Count-1 Do Begin
      RepPages.Items.Add(Copy(Memo1.Lines[I],0,Length(Memo1.Lines[I])-1));
      if Memo1.Lines[I] = '' Then Break;
    End;
    If RepPos = 1 Then RepPos := Memo1.Lines.Count-1
    Else Dec(RepPos,2);
    RepPages.Visible := True;
    Memo1.Modified := FALSE;
    StatBar.Panels[1].Text := '';
    AChoosePage.Enabled := True;
  End;
End;

procedure TEDroreg.SaveRepExecute(Sender: TObject);
begin
  Memo1.Lines.SaveToFile(Opendialog.FileName);
  Memo1.Modified := FALSE;
  StatBar.Panels[1].Text := '';
End;

Procedure TEDroreg.ExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TEDroreg.AddToRepExecute(Sender: TObject);
Var I, T : Integer;
begin
  if RepPages.Text='' Then Begin
    MessageDlg('Please choose a repository page before importing!',mtinformation,[mbok],0);
    Abort;
  End;
  if FBox1.SelCount > 0 Then Begin
    if MessageDlg('Add this/theese file(s) to your delphi repository',mtconfirmation,
      [mbyes,mbno],0) = mryes then Begin
      SetLength(Navne,FBox1.SelCount);
      SetLength(MemoPos,FBox1.SelCount);
      Messageview.Lines.Clear;
      Messageview.Visible := TRUE;
      T := 0;
      AMessageView.Enabled := True;
      For I := 0 To FBox1.Items.Count-1 Do Begin
        if FBox1.Selected[I] Then Begin
          inc(T);
          FBox1.ItemIndex := I;
          Navne[i] := Fbox1.Items[I];
          Memo1.Lines.Insert(RepPos,'');
          Memo1.Lines.Insert(RepPos+1,'['+FBox1.FileName+']');
          Memo1.Lines.Insert(RepPos+2,'Type=FormTemplate');
          Memo1.Lines.Insert(RepPos+3,'Name=');
          Messageview.Lines.Add('Remember to write a name describing '+FBox1.FileName+
                          ' on line :'+IntToStr(RepPos+3));
          Memo1.Lines.Insert(RepPos+4,'Page='+RepPages.Text);
          Memo1.Lines.Insert(RepPos+5,'Icon=');
          Memo1.Lines.Insert(RepPos+6,'Description=');
          Memo1.Lines.Insert(RepPos+7,'Author=');
          Memo1.Lines.Insert(RepPos+8,'DefaultMainForm=0'+RepPages.Text);
          Memo1.Lines.Insert(RepPos+9,'Ancestor=');
          Messageview.Lines.Add('if '+FBox1.FileName+' is inherited from another form then'+
                          ' please remember to write the path to the ancestor form on line :'+IntToStr(RepPos+9));
          Inc(RepPos,10);
          if T = FBox1.Selcount Then Break;
        End;
      End;
    End;
  End;
End;

Procedure TEDroreg.FormCreate(Sender: TObject);
Begin
  Memo1.Lines.Clear;
  Memo1.Modified := FALSE;
  DoubleBuffered := TRUE;
End;

Procedure TEDroreg.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_UP) Or (Key = VK_DOWN) Or (Key = VK_LEFT) Or (Key = VK_RIGHT) Or
    (Key = VK_PRIOR) Or (Key = VK_NEXT) Then
    StatBar.Panels[0].Text := '  '+IntToStr(Memo1.CaretPos.y)+': '+
                              IntToStr(Memo1.CaretPos.x);
  If Memo1.Modified Then
    StatBar.Panels[1].Text := 'Modified';
End;

Procedure TEDroreg.Memo1Enter(Sender: TObject);
begin
  StatBar.Panels[0].Text := '  '+IntToStr(Memo1.CaretPos.y)+': '+
                            IntToStr(Memo1.CaretPos.x);
end;

Procedure TEDroreg.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  StatBar.Panels[0].Text := '  '+IntToStr(Memo1.CaretPos.y)+': '+
                            IntToStr(Memo1.CaretPos.x);
end;

procedure TEDroreg.AChoosePageExecute(Sender: TObject);
begin
  If Not aChoosePage.Checked Then Begin
    RepPages.ManualDock(ControlBar1,ControlBar1);
    aChoosePage.Checked:=True;
    RepPages.Top := 2;
    Reppages.Left:=206;
    RepPages.Visible  :=True;
  End;
End;

procedure TEDroreg.AMessageViewExecute(Sender: TObject);
begin
  If Not AMessageView.Checked Then Begin
    Messageview.ManualDock(ControlBar2,nil,alClient);
    AMessageView.Checked:=True;
    Messageview.Visible :=True;
  End;
end;

procedure TEDroreg.AFloatWindowsExecute(Sender: TObject);
begin
  AChoosepage.Checked  := RepPages.Visible;
  AMessageview.Checked := Messageview.Visible;
end;

End.

